尺取法专题 POJ 3061 POJ 3320 POJ 2566

2024-02-07 17:32
文章标签 poj 专题 取法 3320 3061 2566

本文主要是介绍尺取法专题 POJ 3061 POJ 3320 POJ 2566,希望对大家解决编程问题提供一定的参考价值,需要的开发者们随着小编来一起学习吧!

参考博客:http://blog.chinaunix.net/uid-24922718-id-4848418.html


尺取法:返回推进区间开头和结尾,求满足条件的最小区间的方法称为尺取法。

一般可以用来解决连续的区间问题。

尺取法适用的条件:
1.连续的序列;
2.序列满足单调性。


POJ 3061

题目链接:http://poj.org/problem?id=3061


题意:给长度为n的数组和一个整数m,求总和不小于m的连续子序列的最小长度。


对于样例

10 15
5 1 3 5 10 7 4 9 2 8

算法如图所示:


尺取法的4个步骤:

1.初始化左右端点
    2.不断扩大右端点,直到满足条件
    3.如果第二步中无法满足条件,则终止,否则更新结果
    4.将左端点扩大1,然后回到第二步

复杂度为O(n)


#include <iostream>
#include <cstdio>
#include <cstring>
#include <algorithm>
#include <vector>
#include <cmath>
using namespace std;
int a[100100];
int main() {int t;scanf("%d", &t);while(t--) {int n, s;scanf("%d %d", &n, &s);int i;for(i = 0; i < n; i++) {scanf("%d", a + i);}int sum = 0, ans = n + 1, l = 0, r = 0; //初始化ans为一个绝对大的数for(;;) {while(r < n && sum < s) {sum += a[r++];}if(sum < s) break;  //退出循环条件ans = min(ans, r - l);sum -= a[l++];}if(ans > n) {ans = 0;}printf("%d\n", ans);}return 0;
} 


POJ 3320

题目链接:http://poj.org/problem?id=3320


题意:给一个数列,找到一个最小的区间,包含这个数列中出现的所有元素。

①不停扩展R,并把扫过知识点丢到map里,直到map的size符合要求。


②更新结果。


②L++,map里的对应key(a[l++])的个数-1,相当于移出这页。


如果对应的key的个数<=0,则应该erase掉这个key,防止map::size()的误判。


#include <iostream>
#include <cstdio>
#include <cstring>
#include <algorithm>
#include <vector>
#include <cmath>
#include <set>
#include <map>
using namespace std;
int a[1000100];
set<int> s;
map<int, int> m;
int main() {int n;scanf("%d", &n);int i;for(i = 0; i < n; i++) {scanf("%d", a + i);s.insert(a[i]); //set用来记录不同元素个数 }int tol = s.size();//l, r分别为首尾指针//res为最小页数,cnt为此时包含的不同元素个数 int l = 0, r = 0, res = n, cnt = 0;for(;;) {while(cnt < tol && r < n) {if(!m[a[r]]) cnt++;m[a[r]]++;r++;}if(cnt < tol) break;  //不能包含所有元素,退出 res = min(res, r - l);m[a[l]]--;if(!m[a[l]]) cnt--;l++;}printf("%d\n", res);return 0;
} 


POJ 2566

题目链接:http://poj.org/problem?id=2566


题意:给n个数的数列和k个询问。
每个询问给出一个数t。求连续的子列和的绝对值,使其与t的最接近。输出这个连续和的绝对值,并且输出这个连续和的左端点和右端点。


感觉挺难的,看了题解后自己写的尺取法死活过不了,,很是绝望。   看了下大神的代码,也挺好理解,而且似乎比我写的还要简洁一下,真佩服。

捣鼓了许久,终于过了。

首先要计算前缀和(注意要加1个0,因为区间可能从头开始)。

然后对sum排序,因为求的是绝对值,所以排序后不会影响结果,求出的子列和也自动都是绝对值了。方便进行尺取。

然后尺取的过程就是不断找最小的差值。

#include <iostream> 
#include <cstdio>
#include <cstring>
#include <algorithm>
#include <cmath>
using namespace std;
typedef pair<int, int> P;
P num[100100];
int main() {int n, k;while(~scanf("%d %d", &n, &k), n + k) {int i;num[0].first = num[0].second = 0; //加入零 for(i = 1; i <= n; i++) {scanf("%d", &num[i].first);num[i].first += num[i - 1].first;num[i].second = i;  //存原始下标}sort(num, num + n + 1); //开始的0也要参与排序,不然枚举不到所有的区间。while(k--) {int t;int l = 0, r = 1, d = 1000000001, ans, ansl, ansr, tmp;scanf("%d", &t);//r大于n后只能l前进,此时越来越小,所以停下即可 //d为0时表示找到了与t相等的数,最优 while(r <= n && d) {tmp = num[r].first - num[l].first;if(abs(tmp - t) < d) {d = abs(tmp - t);ans = tmp;ansl = num[l].second;ansr = num[r].second;}if(tmp < t) r++;else if(tmp > t) l++;if(r == l) r++;}if(ansl > ansr) swap(ansl, ansr);printf("%d %d %d\n", ans, ansl + 1, ansr);}}return 0;
}


这篇关于尺取法专题 POJ 3061 POJ 3320 POJ 2566的文章就介绍到这儿,希望我们推荐的文章对编程师们有所帮助!



http://www.chinasem.cn/article/688433

相关文章

【专题】2024飞行汽车技术全景报告合集PDF分享(附原数据表)

原文链接: https://tecdat.cn/?p=37628 6月16日,小鹏汇天旅航者X2在北京大兴国际机场临空经济区完成首飞,这也是小鹏汇天的产品在京津冀地区进行的首次飞行。小鹏汇天方面还表示,公司准备量产,并计划今年四季度开启预售小鹏汇天分体式飞行汽车,探索分体式飞行汽车城际通勤。阅读原文,获取专题报告合集全文,解锁文末271份飞行汽车相关行业研究报告。 据悉,业内人士对飞行汽车行业

poj 3974 and hdu 3068 最长回文串的O(n)解法(Manacher算法)

求一段字符串中的最长回文串。 因为数据量比较大,用原来的O(n^2)会爆。 小白上的O(n^2)解法代码:TLE啦~ #include<stdio.h>#include<string.h>const int Maxn = 1000000;char s[Maxn];int main(){char e[] = {"END"};while(scanf("%s", s) != EO

hdu 2602 and poj 3624(01背包)

01背包的模板题。 hdu2602代码: #include<stdio.h>#include<string.h>const int MaxN = 1001;int max(int a, int b){return a > b ? a : b;}int w[MaxN];int v[MaxN];int dp[MaxN];int main(){int T;int N, V;s

poj 1511 Invitation Cards(spfa最短路)

题意是给你点与点之间的距离,求来回到点1的最短路中的边权和。 因为边很大,不能用原来的dijkstra什么的,所以用spfa来做。并且注意要用long long int 来存储。 稍微改了一下学长的模板。 stack stl 实现代码: #include<stdio.h>#include<stack>using namespace std;const int M

poj 3259 uva 558 Wormholes(bellman最短路负权回路判断)

poj 3259: 题意:John的农场里n块地,m条路连接两块地,w个虫洞,虫洞是一条单向路,不但会把你传送到目的地,而且时间会倒退Ts。 任务是求你会不会在从某块地出发后又回来,看到了离开之前的自己。 判断树中是否存在负权回路就ok了。 bellman代码: #include<stdio.h>const int MaxN = 501;//农场数const int

poj 1258 Agri-Net(最小生成树模板代码)

感觉用这题来当模板更适合。 题意就是给你邻接矩阵求最小生成树啦。~ prim代码:效率很高。172k...0ms。 #include<stdio.h>#include<algorithm>using namespace std;const int MaxN = 101;const int INF = 0x3f3f3f3f;int g[MaxN][MaxN];int n

poj 1287 Networking(prim or kruscal最小生成树)

题意给你点与点间距离,求最小生成树。 注意点是,两点之间可能有不同的路,输入的时候选择最小的,和之前有道最短路WA的题目类似。 prim代码: #include<stdio.h>const int MaxN = 51;const int INF = 0x3f3f3f3f;int g[MaxN][MaxN];int P;int prim(){bool vis[MaxN];

poj 2349 Arctic Network uva 10369(prim or kruscal最小生成树)

题目很麻烦,因为不熟悉最小生成树的算法调试了好久。 感觉网上的题目解释都没说得很清楚,不适合新手。自己写一个。 题意:给你点的坐标,然后两点间可以有两种方式来通信:第一种是卫星通信,第二种是无线电通信。 卫星通信:任何两个有卫星频道的点间都可以直接建立连接,与点间的距离无关; 无线电通信:两个点之间的距离不能超过D,无线电收发器的功率越大,D越大,越昂贵。 计算无线电收发器D

poj 1502 MPI Maelstrom(单源最短路dijkstra)

题目真是长得头疼,好多生词,给跪。 没啥好说的,英语大水逼。 借助字典尝试翻译了一下,水逼直译求不喷 Description: BIT他们的超级计算机最近交货了。(定语秀了一堆词汇那就省略吧再见) Valentine McKee的研究顾问Jack Swigert,要她来测试一下这个系统。 Valentine告诉Swigert:“因为阿波罗是一个分布式共享内存的机器,所以它的内存访问

uva 10061 How many zero's and how many digits ?(不同进制阶乘末尾几个0)+poj 1401

题意是求在base进制下的 n!的结果有几位数,末尾有几个0。 想起刚开始的时候做的一道10进制下的n阶乘末尾有几个零,以及之前有做过的一道n阶乘的位数。 当时都是在10进制下的。 10进制下的做法是: 1. n阶位数:直接 lg(n!)就是得数的位数。 2. n阶末尾0的个数:由于2 * 5 将会在得数中以0的形式存在,所以计算2或者计算5,由于因子中出现5必然出现2,所以直接一